/* LoveMachine++
   Version 02
   Mikael Fernstrom
   2012-11-11
   LMv02
*/

// select current output pin
int curA = 2;
int curB = 3;
int curC = 4;
int curD = 8;
int curE = 9;

//select sensor pin
int senA = 5;
int senB = 6;
int senC = 7;
int senD = 10;
int senE = 11;

//set current level, sensitivity
int ampA = 12;
int ampB = 13;

//variables
int i = 0;
int j = 0;
int x = 0;
int hival = 0;
int loval = 0;

int SensorValues[256];

// Initialisation ********************

void setup()
{
  // start serial communication
  Serial.begin(115200); 
  // set output pins
  pinMode(curA, OUTPUT);
  pinMode(curB, OUTPUT);
  pinMode(curC, OUTPUT);
  pinMode(curD, OUTPUT);
  pinMode(curE, OUTPUT);
  pinMode(senA, OUTPUT);
  pinMode(senB, OUTPUT);
  pinMode(senC, OUTPUT);
  pinMode(senD, OUTPUT);
  pinMode(senE, OUTPUT);
  pinMode(ampA, OUTPUT);
  pinMode(ampB, OUTPUT);
}

// Main Loop ********************

void loop()
{  
  x = 0;

// set the sensitivity  
  setRange(1);
      
//scan all nodes
  for(i=0;i<16;i++)
  {
    setCur(i);
    for(j=0;j<16;j++)
    {
      setSense(j);
      x++;
      SensorValues[x] = analogRead(A0);
    }
  }

 x = 0;
// send data
 for(x=2;x<18;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=19;x<35;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=36;x<52;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=53;x<69;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=70;x<86;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=87;x<103;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=104;x<120;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=121;x<137;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=138;x<154;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=155;x<171;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=172;x<188;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=189;x<205;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=206;x<222;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=223;x<239;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }
  for(x=240;x<256;x++)
  {
    Serial.print(SensorValues[x]);
    Serial.print(" ");
  }

// terminate packet
  Serial.println("X");
//  delay(500);
}

// Functions ********************

void setCur(int x)
{
  switch(x)
  {
    case 0:
      digitalWrite(curA, LOW);
      digitalWrite(curB, LOW);
      digitalWrite(curC, LOW);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 1:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, LOW);
      digitalWrite(curC, LOW);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 2:
      digitalWrite(curA, LOW);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, LOW);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 3:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, LOW);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 4:
      digitalWrite(curA, LOW);
      digitalWrite(curB, LOW);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 5:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, LOW);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 6:
      digitalWrite(curA, LOW);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 7:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, LOW);
      digitalWrite(curE, HIGH);
      break;
    case 8:
      digitalWrite(curA, LOW);
      digitalWrite(curB, LOW);
      digitalWrite(curC, LOW);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 9:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, LOW);
      digitalWrite(curC, LOW);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 10:
      digitalWrite(curA, LOW);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, LOW);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 11:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, LOW);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 12:
      digitalWrite(curA, LOW);
      digitalWrite(curB, LOW);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 13:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, LOW);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 14:
      digitalWrite(curA, LOW);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    case 15:
      digitalWrite(curA, HIGH);
      digitalWrite(curB, HIGH);
      digitalWrite(curC, HIGH);
      digitalWrite(curD, HIGH);
      digitalWrite(curE, LOW);
      break;
    default:
      // do nothing
      break;    
  }
}

void setSense(int x)
{
  switch(x)
  {
    case 0:
      digitalWrite(senA, LOW);
      digitalWrite(senB, LOW);
      digitalWrite(senC, LOW);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 1:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, LOW);
      digitalWrite(senC, LOW);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 2:
      digitalWrite(senA, LOW);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, LOW);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 3:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, LOW);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 4:
      digitalWrite(senA, LOW);
      digitalWrite(senB, LOW);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 5:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, LOW);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 6:
      digitalWrite(senA, LOW);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 7:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, LOW);
      digitalWrite(senE, HIGH);
      break;
    case 8:
      digitalWrite(senA, LOW);
      digitalWrite(senB, LOW);
      digitalWrite(senC, LOW);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 9:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, LOW);
      digitalWrite(senC, LOW);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 10:
      digitalWrite(senA, LOW);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, LOW);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 11:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, LOW);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 12:
      digitalWrite(senA, LOW);
      digitalWrite(senB, LOW);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 13:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, LOW);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 14:
      digitalWrite(senA, LOW);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    case 15:
      digitalWrite(senA, HIGH);
      digitalWrite(senB, HIGH);
      digitalWrite(senC, HIGH);
      digitalWrite(senD, HIGH);
      digitalWrite(senE, LOW);
      break;
    default:
      // do nothing
      break;    
  }  
}

void setRange(int x)
{
  switch(x)
  {
    // the sensitivity works inversly proportinal to the current, 
    // as hi-R makes the output close to Vcc and lo-R output close to GND
    case 0:
    // 560k resistor, high sensitivity
      digitalWrite(ampA, LOW);
      digitalWrite(ampB, HIGH);
      break;
    case 1:
    // 47k resistor, low sensitivity
      digitalWrite(ampA, HIGH);
      digitalWrite(ampB, LOW);
    break;
    default:
    // do nothing
    break;
  }
}
